// GMap.h: interface for the GMap class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _G_MAP_INCLUDE_
#define _G_MAP_INCLUDE_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GClasses.h"
#include "file_type.h"
#include "GStrela.h"
#include "GPowerUp.h"

#define MAX_POWERUPS_ON_MAP 10

enum {
	TYPE_SMALL = 0,
	TYPE_LARGE
};


class GMap  // obasahuje kompletni mapu cele hry !!
{
public:
	bool CanShoot(int x, int y);
	bool CanWalk(int x, int y);
	bool CanShoot(int x, int y, int dst);
	bool CanWalk(int x, int y, int dst);
	void GetFreePos(int *x, int *y, int dst);
	void InsertKilled(int x, int y);
	void PickPowerUps(GRun *run);
	void NewPowerUp();
	bool Hit(GSoldier *sold, GStrela *strela, GRun *run);
	void ShootHits(GRun *run);
	void NewStrela(int x, int y, int angle, int ID, int who, double speed, int zbranID);
	void Destroy();
	void DestroyArrays();
	void Move();
	bool LoadGFX();
	// kreslici fce
	void Draw(int CX, int CY, bool stin);


	void AddObject(st_GFile_Object ob);
	void InitDone();
	void Reset(int X, int Y);

	GMap();
	virtual ~GMap();

	BITMAP *m_bGround; // pohrch podkladu
	BITMAP *m_bWalk;   // mapa pruchodnosti

	int     m_mode; // typ vykreslovani (TYPE_SMALL, TYPE_LARGE)

	int     m_sx; // velikost x pro hraci plochu
	int     m_sy; // velikost y pro hraci plochu

	GPowerUp  *m_power[MAX_POWERUPS_ON_MAP]; // pocet powerupu na mape
	int      m_nextpwr;  // jak dlouho zbyva do pridani dalsiho powerupu

	GObject *m_objects[MAX_OBJECTS_ON_MAP]; // pole ukazatelu na GObject
	int      m_cobjects;       // pocet platnych ukazatelu v poli m_objects (aby se nemuselo prochazet uplne cele)

	GStrela  m_strely[MAX_STREL_ON_MAP];
	int      m_strel;
	int      m_strelA;

private:
	void FillLargeGround();
};

#endif // #ifndef _G_MAP_INCLUDE_
