// GMenuSet.cpp: implementation of the GMenuSet class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GMenuSet.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GMenuSet::GMenuSet()
{
	m_item = 0;
}

GMenuSet::~GMenuSet()
{

}

void GMenuSet::Run(GRun *run, GMenuBack *back)
{
	m_run = run;
	m_back = back;
   clear_keybuf();
	for(;;) {
		tmr  = 5; // 50 ms; -> 20 refreshu za sekundu
		Draw();
		if (ProcessKeys()) break;
		while (tmr != 0); // cekame, za dobehe timer
	}
	m_back->FadeOut();
}

bool GMenuSet::LoadGfx()
{
	return true;
}

void GMenuSet::Destroy()
{	
}

bool GMenuSet::ProcessKeys()
{
	int  c, c2;

	while(keypressed()) {
		c2 = readkey();
		c = (c2 >> 8);

		switch (c) {
		case KEY_UP : 
			if(--m_item < 0) m_item = it_zpet;
			break;
		case KEY_DOWN :
			if(++m_item > it_zpet) m_item = 0;
			break;
		case KEY_LEFT :
			if (m_item == it_postava) 
				if(--m_run->m_sold[0].m_ID < 0) m_run->m_sold[0].m_ID = MAX_SOLDIERS-1;
			if (m_item == it_mapa) 
				if(--m_run->m_mapa < 1) m_run->m_mapa = 1;
			if (m_item == it_svetlo) 
				m_run->m_svetlo = GFX_LOADED_NORMAL;
			break;
		case KEY_RIGHT :
			if (m_item == it_postava) 
				if((++m_run->m_sold[0].m_ID) >= MAX_SOLDIERS) m_run->m_sold[0].m_ID = 0;
			if (m_item == it_mapa) 
				if(++m_run->m_mapa > m_run->m_maps) m_run->m_mapa = m_run->m_maps;
			if (m_item == it_svetlo) 
				m_run->m_svetlo = GFX_LOADED_DARK;
			break;
		case KEY_ENTER :

			if (m_item == it_zpet) return true;
			break;
		case KEY_BACKSPACE :
		case KEY_DEL :
			if (m_run->m_sold[0].m_name[0] != '\0')
				m_run->m_sold[0].m_name[strlen(m_run->m_sold[0].m_name)-1] = '\0';
			break;
		default :
			c = c2 & 0xff;
			if (islower(c)) c = _toupper(c); // aby se nepsalo malejma pismenkama
			if (GetFontID(c) != -1) {
				int len = strlen(	m_run->m_sold[0].m_name);
				if (len < 50) {
					m_run->m_sold[0].m_name[len] = c;
					m_run->m_sold[0].m_name[len+1] = '\0';
				}
			}
		}
	}

	return false;
}

void GMenuSet::Draw()
{
	m_back->Acquire();
	m_back->Clear();

	// menu
	draw_sprite(m_back->m_back, b_solds_big[Sparams[m_run->m_sold[0].m_ID].bindex], 300, 70);

	char s[80];
	sprintf(s, "JMENO - %s", m_run->m_sold[0].m_name);
	DrawMyFontCenter(m_back->m_back, 320, 110, Col(0), s);
	DrawMyFontCenter(m_back->m_back, 320, 150, Col(1), "< POSTAVA >");
	sprintf(s, "< MAPA %d >", m_run->m_mapa);
	DrawMyFontCenter(m_back->m_back, 320, 190, Col(2), s);
	if (m_run->m_svetlo == GFX_LOADED_NORMAL)
		DrawMyFontCenter(m_back->m_back, 320, 230, Col(3), "< SVETLO VE DEN >");
	else
		DrawMyFontCenter(m_back->m_back, 320, 230, Col(3), "< SVETLO V NOC >");

	DrawMyFontCenter(m_back->m_back, 320, 270, Col(4), "ZPET");

	// okoli
	textprintf_centre(m_back->m_back, font, 320,  50, makecol(255,10,10), "Nastaveni");
	m_back->Release();;

	m_back->Flip();
}

int GMenuSet::Col(int index)
{
	if (index == m_item) return makecol(255,255,255);
	return makecol(128,128,128);
}

