// GMenuSingle.cpp: implementation of the GMenuSet class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GMenuSingle.h"
#include "GRun.h"

#include "inifile.h"
extern st_inifile ini;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GMenuSingle::GMenuSingle()
{
	m_item = 0;
	m_enemy = ini.pocitacu;

}

GMenuSingle::~GMenuSingle()
{
	ini.pocitacu = m_enemy;
}

void GMenuSingle::Run(GRun *run, GMenuBack *back)
{
	m_run = run;
	m_back = back;
   clear_keybuf();
	for(;;) {
		tmr  = 5; // 50 ms; -> 20 refreshu za sekundu
		Draw();
		if (ProcessKeys()) break;
		while (tmr != 0); // cekame, za dobehe timer
	}
	m_back->FadeOut();
}

bool GMenuSingle::LoadGfx()
{
	return true;
}

void GMenuSingle::Destroy()
{	
}

bool GMenuSingle::ProcessKeys()
{
	int  c, c2;

	if (keypressed()) {
		c2 = readkey();
		c = (c2 >> 8);

		switch (c) {

		case KEY_UP : 
			if(--m_item < 0) m_item = it_zpet;
			break;
		case KEY_DOWN :
			if(++m_item > it_zpet) m_item = 0;
			break;

		case KEY_LEFT :
			if (m_item == it_enemy) 
				if(--m_enemy < 0) m_enemy = 0;
			break;
		case KEY_RIGHT :
				if(++m_enemy >= MAX_PLAYERS-1) m_enemy = MAX_PLAYERS-1;
			break;

		case KEY_ENTER :

			if (m_item == it_zpet) return true;

			if (m_item == it_play) RunSingle();

			break;
		}
	}
	clear_keybuf();

	return false;
}

void GMenuSingle::Draw()
{
	m_back->Acquire();
	m_back->Clear();

	// menu
	char s[80];
	sprintf(s, "< %d UI >", m_enemy);
	DrawMyFontCenter(m_back->m_back, 320, 170, Col(0), s);
	DrawMyFontCenter(m_back->m_back, 320, 210, Col(1), "HRA");
	DrawMyFontCenter(m_back->m_back, 320, 250, Col(2), "ZPET");

	DrawMyFontCenter(m_back->m_back, 320,  50, makecol(255,10,10), "SINGLE PLAYER");
	m_back->Release();

	m_back->Flip();
}

int GMenuSingle::Col(int index)
{
	if (index == m_item) return makecol(255,255,255);
	return makecol(128,128,128);
}


void GMenuSingle::RunSingle()
{
	hscreen.FadeDown();

	m_run->m_net.m_connected = false;
	m_run->InitSingle(m_enemy+1);
	m_run->Init();
	m_run->Run();

//run.m_net.ShutDown();
}
