// GNet.h: interface for the GNet class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GNET_H__7A44CF00_3ECB_11D4_8F75_FCC537DFDF0B__INCLUDED_)
#define AFX_GNET_H__7A44CF00_3ECB_11D4_8F75_FCC537DFDF0B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GClasses.h"
#include "MultiPlay.h"


#define MESS_SOLDIER  1 // poloha vojaka & jeho strel
#define MESS_KILLED   2 // Hrac, ktery tuto zpravu poslal byl zabit
#define MESS_FRAG     3 // Urceno hraci, ktery zabil nekoho jineho
 

typedef struct {
	DWORD    type;
	byte     ID;
	signed _int8   a_shield;
	signed _int8   a_krev;
	byte     params;
	byte     angle;
	_int16   frags;
	_int16   health;
	byte     zbran;
	_int16   x, y; // pozice
	_int16   shield;  // stit
	_int16   strel;
} st_msg_soldier;

typedef struct {
	byte   ID;
	byte   angle;
	_int16 x, y; // pozice
} st_msg_strela;


typedef struct {
	DWORD    type;
} st_msg_frag;

typedef struct {
	DWORD    type;
	byte     zpusob; // zpusob smrti
} st_msg_killed;

/*
 typedef struct {
	DWORD type;
	int monitored; // monitorovany hrac
	int players;   // pocet hracu
	int shoots;    // pocet strel
	// pointer na players
	// pointer na strely
 } st_msg_server;
*/

class GNet  
{
public:
	void ProcesKilledMess(int from, GRun *run);
	void SendFrag(int kdo, int jak);
	void ShutDown();
	void UpdateSoldiers(GRun *run);
	bool EnterGame(GRun *run);
	void Receive(GRun *run);
	void Send(GRun *run);
	GNet();
	virtual ~GNet();

	int m_sended;
	int m_received;
	int m_myindex;

	int   m_frommess;

	bool  m_connected;  

	byte m_buf[10000];
//	 extern NDX_Connect *net;
private:
	void ProcessMess(int from, GRun *run);
	void ProcessSoldierMess(int from, GRun *run);
	void ProcessFragMess(int from, GRun *run);
};


#endif // !defined(AFX_GNET_H__7A44CF00_3ECB_11D4_8F75_FCC537DFDF0B__INCLUDED_)
