// GObject.h: interface for the GObject class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _G_OBJECT_INCLUDE_
#define _G_OBJECT_INCLUDE_

#include "GClasses.h"
#include "objects.h"

class GObject  
{
public:
	void LoadGFX();
	void Destroy();
	void UpdateTmp();
	void ComputeRect();
	void Move();
	void Init(int x, int y, int ID);
	void Draw(BITMAP *dest, int x, int y, int hi, bool shadow);
	GObject();
	virtual ~GObject();

	MYRECT m_rect;  // obdelnik, ktery je diky tomuto objektu neprujezdny;
	RECT   m_srect; // standartni obdelnik
	bool   m_smashed;  // je-li objekt typu OBJECT_SOFT, tak m_smashed urcuje, zda je objekt rozjety 
	int    m_krev;     // index krve pri animaci 

	double  m_x;     // x-ova souradnice stredu 
	double  m_y;     // y-ova souradni ce stredu

	double  m_dx;      // je-li objekt flying, tak tohle urcuje, kam poleti
	double  m_dy;      // je-li objekt flying, tak tohle urcuje, kam poleti
	double  m_ralpha;  // uhel smeru pohybu v radianech

	double  m_angle; // uhel otoceni ( pouziva se u OBJECT_SOFT a OBJECT_FLYING )
	double  m_angles;
	double  m_turning;
	double  m_speed;

	BITMAP *m_btmp;
	int     m_tmpx;
	int     m_tmpa;

	st_GObjects_params   m_par;
	int                  m_ID;
private:
};

#endif // #ifndef _G_OBJECT_INCLUDE_

