// GStrela.cpp: implementation of the GStrela class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GStrela.h"
#include "GMap.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GStrela::GStrela()
{
	m_dist = 5;
	m_active = false;
}

GStrela::~GStrela()
{

}

/*////////////////////////////////////////////////////////////////////////////////
	Inicializace parametru strely
*/
void GStrela::Init(int x, int y, int angle, int ID, int who, double speed)
{
	m_active = true;
	m_ox = m_x = x;
	m_oy = m_y = y;
	m_angleRad = angle*DPI/256;
	m_angle = angle;
	m_ID = ID;
	m_speed = Nparams[m_ID].speed;
	if (speed > 0) m_speed += speed;
	m_who = who; // aby hrac netrefil sam sebe ;)
}

/*////////////////////////////////////////////////////////////////////////////////
	Pohyb strely - a pripakny vybuch :)
*/
void GStrela::Move(GMap *map)
{
	m_x += cos(m_angleRad) * m_speed;
	m_y -= sin(m_angleRad) * m_speed;

	if ((m_x < -10) || (m_y < -10) ||
		(m_x > map->m_sx+10) || (m_y > map->m_sy+10)) {
		m_active = false;
		return;
	}
	if (pow(pow(m_x-m_ox,2)+pow(m_y-m_oy,2),0.5) > Nparams[m_ID].dist) {
			for (int i = 0; i < Nparams[m_ID].explosive; i++)
				map->NewStrela(m_x+rand()%30-15, m_y+rand()%30-15, rand()%256, m_ID+1, m_who, 0);
			m_active = false;
			return;
	}
}

/*////////////////////////////////////////////////////////////////////////////////
	Kresleni strely
*/
void GStrela::Draw(int CX, int CY, bool stin)
{
	CX = m_x - CX + (DF_X-5) / 2;
	CY = m_y - CY + (DF_Y-5)  / 2;
		rotate_sprite(hscreen.m_back, b_strel[m_ID], CX, CY, itofix(-m_angle));
}

/*////////////////////////////////////////////////////////////////////////////////
	Vrati poskozeni a exploduje
*/
int GStrela::GetDemage(GMap  *map)
{
	for (int i = 0; i < Nparams[m_ID].explosive; i++)
		map->NewStrela(m_x+rand()%30-15, m_y+rand()%30-15, rand()%256, m_ID+1, m_who, 0);
	return Nparams[m_ID].demage;
}
