// GView.cpp: implementation of the GView class.
//
//////////////////////////////////////////////////////////////////////

#include "stdh.h"
#include "soldiers.h"
#include "zbrane.h"
#include "GSoldier.h"
#include "GView.h"
#include "GMap.h"
#include "GRun.h"


#define DXTABLE    900
#define DXTABLESN  30

BITMAP*  b_gv[MAX_GV_BITMAPS];         /// bitmapy pro GView
BITMAP*  b_topten[3];


#define MAX_UKILL 7
const char u_kill[MAX_UKILL][40] = {
	"TI PODLEHL",
	"NEODOLAL TVEMU NAPORU",
	"SE DIKY TOBE VALI V KRVY",
	"OD TEBE DOSTAL JAK SEDLACI U CHLUMCE",
	"JE UPLNE LEVEJ A UPLNE MRTVEJ",
	"ODESEL DO VECNYCH LOVIST",
	"UZ NENI MEZI NAMI"
};

#define MAX_UKILLED 5
const char u_killed[MAX_UKILLED][60] = {
	"TE DOSTAL",
	"TE ZABIL",
	"TE UPLNE VYMAZAL, KOUKEJ SE TROCHU SNAZIT",
	"JE PRVNI, KOMU SE POMSTI",
	"SI TE PODAL"
};




//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

/*////////////////////////////////////////////////////////////////////////////////
  NULL-ovaci konstruktor
*/
GView::GView()
{
	m_zamerovac = false;
}

/*////////////////////////////////////////////////////////////////////////////////
  Prazdnu destruktor
*/
GView::~GView()
{
}

/*////////////////////////////////////////////////////////////////////////////////
  Nakresli uplne vsechno na hscreen.back
*/
void GView::Draw(GRun *run)
{
	bool stin = run->m_stin;
	int i;

 // cast pod vojaky
	run->m_map.Draw(m_Cx, m_Cy, stin);

	for (i = 0 ; i < run->m_soldiers; i++)
		run->m_sold[i].Draw(hscreen.m_back, m_Cx, m_Cy);


	// Ladici vypisy
#ifdef _DEBUG
	char s[50];
	sprintf(s,"CX=%d CY=%d ",m_Cx, m_Cy);
	textout(hscreen.m_back, font, s, 10, 25, makecol(200,200,200));

	sprintf(s,"strel=%d celkem=%d ",run->m_map.m_strelA, run->m_map.m_strel);
	textout(hscreen.m_back, font, s, 10, 40, makecol(200,200,200));

	if (run->m_server) textout(hscreen.m_back, font, "You are server", 10, 55, makecol(200,200,200));
	else textout(hscreen.m_back, font, "You are client", 10, 55, makecol(200,200,200));

	textprintf(hscreen.m_back, font, 10,  70, makecol(200,200,200), "Current players : %d",run->m_soldiers);
	textprintf(hscreen.m_back, font, 10,  95, makecol(200,200,200), "Rec. messages %d, send messages %d",run->m_net.m_received, run->m_net.m_sended);
	textprintf(hscreen.m_back, font, 10, 110, makecol(200,200,200), "Me %d, Form %d",run->m_monsol, run->m_net.m_frommess);
	textprintf(hscreen.m_back, font, 10, 110, makecol(200,200,200), "Frags status :");
	for (i = 0; i < run->m_soldiers; i++)
		textprintf(hscreen.m_back, font, 10, 132+20*i, makecol(200,200,200), "%d",run->m_sold[i].m_frags);
#endif

// soucasny vojak
	DrawCurSold(run);

	// ji-li nas hrac mrtvy, tak nakreslime tabulku fragu
	if (run->m_sold[run->m_monsol].m_health <= 0)
		DrawFrags(run);
	else m_dxtable = DXTABLE;
}

/*////////////////////////////////////////////////////////////////////////////////
  Inicializuje GView tridu
  car  : ukazatel na moniotrovane auto
*/
void GView::Init(GSoldier *sol)
{
	m_Cx = sol->m_x - DF_X/2;
	m_Cy = sol->m_y - DF_Y/2;
	// resetovani zprav
	int i;
	for (i = 0; i < MAX_MESSAGES; i++)
		m_mess[i][0] = '\0';
}

/*////////////////////////////////////////////////////////////////////////////////
  Posune kameru smerem k jejimu pozadovanemumistu ( to zavisi na smeru a rychlosti auta )
*/
void GView::UpdateCamera(GRun *run)
{
	GSoldier *sol = &(run->m_sold[0]);
	GMap *map = &(run->m_map);
	// vypocet posunuti kamery
	m_Cx = sol->m_x /*- DF_X/2*/;
	m_Cy = sol->m_y /*- DF_Y/2*/;

	if(m_Cx < DF_X/2) m_Cx = DF_X/2;
	if(m_Cy < DF_Y/2) m_Cy = DF_Y/2;
	if(m_Cx > map->m_sx - DF_X/2) m_Cx = map->m_sx - DF_X/2;
	if(m_Cy > map->m_sy  - DF_Y/2) m_Cy = map->m_sy - DF_Y/2;
}

/*////////////////////////////////////////////////////////////////////////////////
  Pred ukoncenim programu znici ( uvolni ) vsechny alokovane bitmapy
*/
void GView::Destroy()
{
	int i;
	for ( i = 0; i < MAX_GV_BITMAPS; i++) {
		if (b_gv[i] == NULL) destroy_bitmap(b_gv[i]);
		b_gv[i] = NULL;
	}

	for ( i = 0; i < 3; i++) {
		if (b_topten[i] == NULL) destroy_bitmap(b_topten[i]);
		b_topten[i] = NULL;
	}
}

/*////////////////////////////////////////////////////////////////////////////////
  Nacte grafiku
*/
bool GView::LoadGFX(GRun *run)
{
	Destroy();

	if (!run->LoadBitmaps(&b_gv[0], MAX_GV_BITMAPS, 1, "V%d.bmp")) return false;

	if (!run->LoadBitmaps(&b_topten[0], 3, 1, "topten%d.bmp")) return false;

	return true;
}

/*////////////////////////////////////////////////////////////////////////////////
  Zobrazi grafiku pro naseho vojaka
*/
void GView::DrawCurSold(GRun *run)
{
	int i;
	GSoldier *sold = &run->m_sold[run->m_monsol];

	int x = sold->m_x - m_Cx + (DF_X) / 2;
	int y = sold->m_y - m_Cy + (DF_Y) / 2;

	// zdravicko a ramecek
	draw_sprite(hscreen.m_back, b_gv[GV_RAMECEK], x-15, y-15);
	if (sold->m_health > 0)
		line(hscreen.m_back, x-12,y+12, x-12+22*sold->m_health/Sparams[sold->m_ID].health, y+12, makecol(255,0,0));
	if (sold->m_shield > 0)
		line(hscreen.m_back, x-12,y+14, x-12+22*sold->m_shield/Sparams[sold->m_ID].shields, y+14, makecol(200,200,255));

	// bonusy
	for (i = 0; i < MAX_BONUS; i++) 
		if (sold->m_bonusy[i] > 0) 
			draw_sprite(hscreen.m_back, b_s_bonus[i], x - 25 + i*10, y+16);


	// soucasna zbran
	if (sold->m_naboje[Zparams[sold->m_zbran].strelaID] > 0) {
		draw_sprite(hscreen.m_back, b_zbraneB[sold->m_zbran], 0, DF_Y-75);
		draw_sprite(hscreen.m_back, b_gv[GV_AMMO+sold->m_zbran],   150, 405);
	}
	textprintf_centre(hscreen.m_back, (FONT *)fonts[FNT_GAME].dat, 250, DF_Y-53, makecol(160,160, 90), "%d",sold->m_naboje[Zparams[sold->m_zbran].strelaID]);

	// fragy
	draw_sprite(hscreen.m_back, b_gv[GV_FRAGS],  290, 405);
	textprintf_centre(hscreen.m_back, (FONT *)fonts[FNT_GAME].dat, 375, DF_Y-53, makecol(255, 6,  6), "%d",sold->m_frags);

	draw_sprite(hscreen.m_back, b_gv[GV_STIT],   405, 405);
	if (sold->m_shield <= 0) i = 0;
	else i = sold->m_shield*100/Sparams[sold->m_ID].shields;
	textprintf_centre(hscreen.m_back, (FONT *)fonts[FNT_GAME].dat, 484, DF_Y-53, makecol(166,166, 90), "%d",i);

	draw_sprite(hscreen.m_back, b_gv[GV_ZDRAVI], 510, 405);
	if (sold->m_health <= 0) i = 0;
	else i = sold->m_health*100/Sparams[sold->m_ID].health;
	textprintf_centre(hscreen.m_back, (FONT *)fonts[FNT_GAME].dat, 595, DF_Y-53, makecol(166,166, 90), "%d",i);

	// zamerovac
	if (m_zamerovac && sold->m_health > 0) {
		int sx,sy,dx,dy;

		double alpha = -atan2(Zparams[sold->m_zbran].dy, Zparams[sold->m_zbran].dx);
		double dst   = pow(pow(Zparams[sold->m_zbran].dx,2)+pow(Zparams[sold->m_zbran].dy,2),0.5);
		sx = x + dst*cos(-sold->m_angleRad-alpha);
		sy = y + dst*sin(-sold->m_angleRad-alpha);
		dx = sx + Nparams[Zparams[sold->m_zbran].strelaID].dist*cos(-sold->m_angleRad);
		dy = sy + Nparams[Zparams[sold->m_zbran].strelaID].dist*sin(-sold->m_angleRad);
		// kdyz nema vojak nabytu, tak kreslime caru cervene
		if (sold->m_nrtf == 0)
			line(hscreen.m_back, sx, sy, dx, dy, makecol(rand()%256, rand()%256, rand()%256));
		else
			line(hscreen.m_back, sx, sy, dx, dy, makecol(250, 0, 0));
	}

	// zpravy
	for (i = 0; i < MAX_MESSAGES; i++)
		if (m_mess[i][0] != '\0')
			textout(hscreen.m_back, font, m_mess[i], 10, 10+20*i, makecol(200, 255, 0));

}

/*////////////////////////////////////////////////////////////////////////////////
  Prida zpravu o sebrani bonusu
*/
void GView::AddBonMessage(int ID)
{
	char c[60];
	sprintf(c, "SEBRAL JSI %s",Pparams[ID].name);
	AddMessage(c);
}

/*////////////////////////////////////////////////////////////////////////////////
  Prida zpravu o zabiti
*/
void GView::AddKillMessage(int kdo, int koho, GRun *run) 
{
	char c[60];
	if (kdo != run->m_monsol && koho != run->m_monsol) return;

	if (kdo == run->m_monsol)
		sprintf(c, "%s %s", run->m_sold[koho].m_name, u_kill[rand()%MAX_UKILL]);
	
	if (koho == run->m_monsol)
		sprintf(c, "%s %s", run->m_sold[kdo].m_name, u_killed[rand()%MAX_UKILLED]);
	
	/*
	sprintf(c, "%s zabil %s",run->m_sold[kdo].m_name, run->m_sold[koho].m_name);
	*/
	AddMessage(c);
}

/*////////////////////////////////////////////////////////////////////////////////
  Prida zpravu
*/
void GView::AddMessage(char *c)
{
	int i;

	// hledame prazdne misto pro zpravu
	for (i = 0; i < MAX_MESSAGES; i++)
		if (m_mess[i][0] == '\0') break;


	// poseneme zpravy v poli
	if (i == MAX_MESSAGES) {
		for (i = 1; i < MAX_MESSAGES; i++)
			strcpy(m_mess[i-1],m_mess[i]);
		i = MAX_MESSAGES-1;
	}

	strcpy(m_mess[i], c);
}

/*////////////////////////////////////////////////////////////////////////////////
  Prida zpravu
*/
void GView::AddFragsMess(int kdo, GRun *run)
{
	char c[60];
	if (kdo == run->m_monsol) {
		sprintf(c ,"DOSAHL JSI %d FRAGU", run->m_sold[kdo].m_frags);
		AddMessage(c);
	}
}

/*////////////////////////////////////////////////////////////////////////////////
  Kresli tabulku fragu
*/
int compare(const void *arg1, const void *arg2);

void GView::DrawFrags(GRun *run)
{
	st_fragstable table[MAX_PLAYERS+1];
	int i,j;
	int col;
	for ( i = 0; i < run->m_soldiers; i++) {
		table[i].ID = i;
		table[i].frags = run->m_sold[i].m_frags;
		strcpy(table[i].name, run->m_sold[i].m_name);
	}

	// z nepochipitelneho duvodu to nefunguje
//	qsort(&table, sizeof(st_fragstable), run->m_soldiers, compare);
	// buble sort
	for(i = 0; i < run->m_soldiers; i++)
		for(j = 1; j < run->m_soldiers; j++)
			if(table[j].frags > table[j-1].frags) {
				table[MAX_PLAYERS] = table[j];
				table[j] = table[j-1];
				table[j-1] = table[MAX_PLAYERS];
			}

	j = run->m_soldiers;
	if (j > 10) j = 10;

	// vlastni kresleni tabulky
	int top;
	int hei = b_topten[1]->h;
	top = 240 - j*hei/2;
	draw_sprite(hscreen.m_back, b_topten[0], 320-b_topten[0]->w/2, top-b_topten[0]->h - m_dxtable/2);
	draw_sprite(hscreen.m_back, b_topten[2], 320-b_topten[2]->w/2, top+j*hei + m_dxtable/2);

	int cent;
	for ( i = 0; i < j; i++) {
		if (i % 2  == 0)
			cent = 320 + m_dxtable;
		else 
			cent = 320 - m_dxtable;

		draw_sprite(hscreen.m_back, b_topten[1], cent-b_topten[1]->w/2, top+hei*i);

		draw_sprite(hscreen.m_back, b_solds[Sparams[run->m_sold[table[i].ID].m_ID].bindex], cent-90, top + hei*i + 5);
		if (table[i].ID == 0) col = makecol(250, 250, 100);
		else col = makecol(250,100,100);
		textprintf_centre(hscreen.m_back, font, cent,  top+hei*i+10, col, table[i].name);
		textprintf_centre(hscreen.m_back, font, cent+75,  top+i*hei+10, col, "%d", table[i].frags);
	}

	if (m_dxtable != 0) m_dxtable -= DXTABLESN;
}

/*////////////////////////////////////////////////////////////////////////////////
  Pro QSORT
*/
int compare(const void *arg1, const void *arg2)
{
	return (((st_fragstable*)arg1)->frags - ((st_fragstable*)arg2)->frags);
}
