// GView.cpp: implementation of the GView class.
//
//////////////////////////////////////////////////////////////////////

#include "stdh.h"
#include "soldiers.h"
#include "zbrane.h"
#include "GSoldier.h"
#include "GView.h"
#include "GObject.h"
#include "GMap.h"
#include "GRun.h"


BITMAP*  b_gv[MAX_GV_BITMAPS];         /// bitmapy pro GView

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

/*////////////////////////////////////////////////////////////////////////////////
  NULL-ovaci konstruktor
*/
GView::GView()
{
}

/*////////////////////////////////////////////////////////////////////////////////
  Prazdnu destruktor
*/
GView::~GView()
{
}

/*////////////////////////////////////////////////////////////////////////////////
  Nakresli uplne vsechno na hscreen.back
*/
void GView::Draw(GRun *run)
{
	//TODO: aby slo nastavit, zda se u aut budou kreslit stin a kour, ale asi to bude zbytecne, protoze jejich narocnost neni zasadni na vykon grafiky
	bool stin = run->m_stin;
	int i;

 // cast pod vojaky
	run->m_map.Draw(m_Cx, m_Cy, stin);

	for (i = 0 ; i < run->m_soldiers; i++)
		run->m_sold[i].Draw(hscreen.m_back, m_Cx, m_Cy);


	//TODO: Odstranit debug napisy ;)
	char s[50];
	sprintf(s,"CX=%d CY=%d ",m_Cx, m_Cy);
	textout(hscreen.m_back, font, s, 10, 25, makecol(200,200,200));

	sprintf(s,"strel=%d celkem=%d ",run->m_map.m_strelA, run->m_map.m_strel);
	textout(hscreen.m_back, font, s, 10, 40, makecol(200,200,200));

	if (run->m_server) textout(hscreen.m_back, font, "You are server", 10, 55, makecol(200,200,200));
	else textout(hscreen.m_back, font, "You are client", 10, 55, makecol(200,200,200));

	textprintf(hscreen.m_back, font, 10,  70, makecol(200,200,200), "Current players : %d",run->m_soldiers);
	textprintf(hscreen.m_back, font, 10,  95, makecol(200,200,200), "Rec. messages %d, send messages %d",run->m_net.m_received, run->m_net.m_sended);
	textprintf(hscreen.m_back, font, 10, 110, makecol(200,200,200), "Me %d, Form %d",run->m_monsol, run->m_net.m_frommess);
	textprintf(hscreen.m_back, font, 10, 110, makecol(200,200,200), "Frags status :");
	for (i = 0; i < run->m_soldiers; i++)
		textprintf(hscreen.m_back, font, 10, 132+20*i, makecol(200,200,200), "%d",run->m_sold[i].m_frags);

// soucasny vojak
	DrawCurSold(run);

	hscreen.Flip();
}

/*////////////////////////////////////////////////////////////////////////////////
  Inicializuje GView tridu
  car  : ukazatel na moniotrovane auto
*/
void GView::Init(GSoldier *sol)
{
	m_Cx = sol->m_x - DF_X/2;
	m_Cy = sol->m_y - DF_Y/2;
}

/*////////////////////////////////////////////////////////////////////////////////
  Posune kameru smerem k jejimu pozadovanemumistu ( to zavisi na smeru a rychlosti auta )
*/
void GView::UpdateCamera(GRun *run)
{
	GSoldier *sol = &(run->m_sold[0]);
	GMap *map = &(run->m_map);
	// vypocet posunuti kamery
	m_Cx = sol->m_x /*- DF_X/2*/;
	m_Cy = sol->m_y /*- DF_Y/2*/;

	if(m_Cx < DF_X/2) m_Cx = DF_X/2;
	if(m_Cy < DF_Y/2) m_Cy = DF_Y/2;
	if(m_Cx > map->m_sx - DF_X/2) m_Cx = map->m_sx - DF_X/2;
	if(m_Cy > map->m_sy  - DF_Y/2) m_Cy = map->m_sy - DF_Y/2;
}

/*////////////////////////////////////////////////////////////////////////////////
  Pred ukoncenim programu znici ( uvolni ) vsechny alokovane bitmapy
*/
void GView::Destroy()
{
	for (int i = 0; i < MAX_GV_BITMAPS; i++) {
		if (b_gv[i] == NULL) destroy_bitmap(b_gv[i]);
		b_gv[i] = NULL;
	}
}

/*////////////////////////////////////////////////////////////////////////////////
  Nacte grafiku
*/
bool GView::LoadGFX()
{
	char s[60];
	PALLETE pal;

	Destroy();
	for (int i = 0; i < MAX_GV_BITMAPS; i++) {
		sprintf(s,"V%d.bmp",i+1);
		b_gv[i] = load_bitmap(s,pal);
		if (b_gv[i] == NULL) {
			return false;
		}
	}
	return true;
}

/*////////////////////////////////////////////////////////////////////////////////
  Nacte grafiku
*/
void GView::DrawCurSold(GRun *run)
{
	int i;
	GSoldier *sold = &run->m_sold[run->m_monsol];

	int x = sold->m_x - m_Cx + (DF_X) / 2;
	int y = sold->m_y - m_Cy + (DF_Y) / 2;

	// zdravicko a ramecek
	draw_sprite(hscreen.m_back, b_gv[GV_RAMECEK], x-15, y-15);
	if (sold->m_health > 0)
		line(hscreen.m_back, x-12,y+12, x-12+22*sold->m_health/Sparams[sold->m_ID].health, y+12, makecol(255,0,0));
	if (sold->m_shield > 0)
		line(hscreen.m_back, x-12,y+14, x-12+22*sold->m_shield/Sparams[sold->m_ID].shields, y+14, makecol(200,200,255));

	// soucasna zbran
	draw_sprite(hscreen.m_back, b_zbraneB[sold->m_zbran], 0, DF_Y-75);

	text_mode(-1);
	// zdravi atd.
	draw_sprite(hscreen.m_back, b_gv[GV_AMMO+sold->m_zbran],   170, DF_Y-50);
	textprintf_centre(hscreen.m_back, (FONT *)fonts[FNT_GAME].dat, 250, DF_Y-50, makecol(160,160, 90), "%d",sold->m_naboje[Zparams[sold->m_zbran].strelaID]);

	draw_sprite(hscreen.m_back, b_gv[GV_FRAGS],  300, DF_Y-50);
	textprintf_centre(hscreen.m_back, (FONT *)fonts[FNT_GAME].dat, 375, DF_Y-50, makecol(166,166,  0), "%d",sold->m_frags);

	draw_sprite(hscreen.m_back, b_gv[GV_STIT],   415, DF_Y-50);
	if (sold->m_shield <= 0) i = 0;
	else i = sold->m_shield*100/Sparams[sold->m_ID].shields;
	textprintf_centre(hscreen.m_back, (FONT *)fonts[FNT_GAME].dat, 484, DF_Y-50, makecol(166,166, 90), "%d",i);

	draw_sprite(hscreen.m_back, b_gv[GV_ZDRAVI], 520, DF_Y-50);
	if (sold->m_health <= 0) i = 0;
	else i = sold->m_health*100/Sparams[sold->m_ID].health;
	textprintf_centre(hscreen.m_back, (FONT *)fonts[FNT_GAME].dat, 595, DF_Y-50, makecol(166,166, 90), "%d",i);

}
