// GView.h: interface for the GView class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _G_VIEW_INCLUDE_
#define _G_VIEW_INCLUDE_

#include "GClasses.h"

#define MAX_GV_BITMAPS 10
#define GV_RAMECEK 0
#define GV_ZDRAVI  1
#define GV_STIT    2
#define GV_FRAGS   3
#define GV_AMMO    4


extern BITMAP* b_gv[MAX_GV_BITMAPS];

typedef struct {
	int   frags;
	char  name[50];
} st_fragstable;

#define MAX_MESSAGES  6  // maximalni pocet zprav vlevo nahore na obrazovce

class GView  
{
public:
	void DrawFrags(GRun *run);
	void AddFragsMess(int kdo, GRun *run);
	void AddMessage(char *c);
	void AddKillMessage(int kdo, int koho, GRun *run);
	void AddBonMessage(int ID);
	void DrawCurSold(GRun *run);
	bool LoadGFX();
	void Destroy();
	void UpdateCamera(GRun *run);
	void Init(GSoldier *car);
	void Draw(GRun *run);
	GView();
	virtual ~GView();

	int m_Cx; // X-ova souradnice pohledu (Camera x)
	int m_Cy; // Y-ova souradnice pohledu (Camera y)

	char m_mess[MAX_MESSAGES][100];
};

#endif // #ifndef _G_VIEW_INCLUDE_
