
#include <time.h> // pro random
#include "stdh.h"

#include "soldiers.h"

// Gincludes
#include "GClasses.h"
#include "GRun.h"
#include "GView.h"
#include "GMap.h"

#include "MultiPlay.h"

#include "GMenu.h"

#include "inifile.h"

// globalni unikatni identifikator vytvorny pomoci GuidGen
// {6B3F19A0-417A-11d4-8F75-BB50F7F77D1D}
GUID guid = 
{ 0x6b3f19a0, 0x417a, 0x11d4, { 0x8f, 0x75, 0xbb, 0x50, 0xf7, 0xf7, 0x7d, 0x1d } };

st_inifile ini;
bool load_inifile(GRun *run);
void save_inifile(GRun *run);


const int GFX_BPP[] = {
	8, 15, 16, 24, 32
};

void timer_procedure()
{
	if (tmr > 0) tmr--;
}

END_OF_FUNCTION(timer_procedure);



int main(int argc, char *argv[])
{
   allegro_init();
   install_keyboard();
	install_timer();
	install_mouse();

	GRun run;
	if(!run.SearchForMaps()) {
		allegro_message("Nenalezeny zadne mapy !");
		return 0;
	}	

	load_inifile(&run);

#ifdef _DEBUG
	set_window_title("Kulic - 0.10 - DEBUG");
#else 
	set_window_title("Kulic - 0.10 - RELEASE");
#endif

	// pripraveni timeru
	LOCK_VARIABLE(tmr);
	LOCK_FUNCTION(timer_procedure);
	install_int(timer_procedure, 10);

 
	net = new NDX_Connect;
	if (net == NULL) {
		allegro_message("new NDX_Connect"); // SMULA !!!!
		return 2;
	}

	if (!net->Create(&guid)) {
		return 2;
	}

	srand(time(NULL));
	DF_X = 640;
	DF_Y = 480;

	if (!hscreen.Init(640, 480, GFX_BPP[ini.bpp])) { // DLE INI SOUBORU 
			allegro_message("Nepodarilo se nastavit rozliseni %d*%d*%d !!!\n Spustte setup.exe a vyberte jinou barevnou hloubku", DF_X, DF_Y, GFX_BPP[ini.bpp]); // SMULA !!!!
			return 1;
		}

	text_mode(-1);

	hscreen.Install();

	hscreen.m_mouse = NULL;

	hscreen.Flip();


	// grafika - nacteni
	if(!run.LoadGFX()) {
		allegro_message("Failed in loading GFX !\n  File %s is missing", errch); // SMULA !!!!
		return false;
	}


	GMenu menu;
	menu.LoadGFX(&run);


// HLAVNI HERNI SMYCKA
	while (menu.Run(&run)) {
		if (run.Init()) {
			run.Run();
			run.m_net.ShutDown();
		}
	}
// KONEC HLAVNI SMYCKY 

	menu.Destroy(&run);
	run.Destroy();

	save_inifile(&run);

	hscreen.Destroy();


	delete net;
	net = NULL;

	allegro_exit();

   return 0;
}

END_OF_MAIN();


bool load_inifile(GRun *run) 
{
	int infile;

	if ((infile = _open( INIFILE, _O_BINARY | _O_RDONLY )) == -1 ) {
		allegro_message("Chyby inisoubor %s",INIFILE);
		return false;    // nepodarilo se otevrit soubor
	}

	_read(infile, &ini, sizeof(ini)); // nacteni hlavicky

	_close(infile);


	// zpracovani ini souboru
	// zda budeme pouzivat CD
	if (!ini.cd) cdplay.m_use = false; 

	// zamerovac, autorun
	if (ini.zamerovac) run->m_view.m_zamerovac = true;
	if (ini.autorun)   run->m_autorun = true;
	run->m_mapa = ini.mapa;
	strcpy(run->m_sold[0].m_name, ini.jmeno);
	run->m_sold[0].m_ID = ini.postava;
	run->m_svetlo = ini.svetlo;


	return true;
}


void save_inifile(GRun *run) 
{
		// ulozeni nastaveni
	int infile;
	strcpy(ini.jmeno, run->m_sold[0].m_name);
	ini.postava  = run->m_sold[0].m_ID;
	ini.mapa     = run->m_mapa;
	ini.svetlo   = run->m_svetlo;
	if ((infile = _open( INIFILE, _O_BINARY | _O_WRONLY )) == -1 ) 
		return;    // nepodarilo se otevrit soubor

	_write(infile, &ini, sizeof(ini)); // ulozi inifile

	_close(infile);
}