
#include "stdh.h"
#include "soldiers.h"
#include "zbrane.h"
#include "MultiPlay.h"

HScreen hscreen;
NDX_Connect *net;

int   errno;     // sice nepouzivam, ale jinak bude unresolved exernal pri linkovani :)
char  errch[50]; // chybove hlaseni

int  DF_X = 640; // x-ove rozliseni obrazovky == 640
int  DF_Y = 480;  // y-ove rozliseni obrazovky == 480

volatile int  tmr = 0;  // 10-ms timer
volatile int  tmr2 = 0; // 10-ms timer
volatile int  tmr3 = 0; // 10-ms timer

BITMAP*  b_solds[MAX_SOLD_BITMAPS];    // bitmapy k objektum
BITMAP*  b_deads[MAX_DEADS_BITMAPS];   // bitmapy k objektum
BITMAP*  b_s_run[MAX_RUN_BITMAPS];     // bitmapy nohou pri behu
BITMAP*  b_s_walk[MAX_WALK_BITMAPS];   // bitmapy nohou pri chuzi
BITMAP*  b_s_water[MAX_WATER_BITMAPS]; // bitmapy strikajici wody okolo vojaka
BITMAP*  b_s_bonus[MAX_BONUS];			// obrazky bonusu u vojaka

BITMAP*  b_krev[MAX_KREV_ANIM];				// animace krve
BITMAP*  b_stit[MAX_STIT_ANIM];				// animace stitu
BITMAP*  b_strel[MAX_STREL];				// obrazky strel
BITMAP*  b_zbraneB[MAX_ZBRANE];				// velke obrazky zbrani
BITMAP*  b_zbrane[MAX_ZBRANE][MAX_ZBRAN_ANIM];	// male obrazky zbrani (pod panackem)
BITMAP*  b_powerups[MAX_POWERUPS];			// obrazky bonusu
BITMAP*  b_kour[MAX_KOUR];			// obrazky koure


DATAFILE *fonts; // fonty vseho druhu


// funkce na zjisteni hit - optimalizovane
// if (dist > pow((pow(abs(x-m_x),2)+pow(abs(y-m_y),2)),0.5)) return true; // strela zasah
// if (!IsOut(x, y, m_x, m_y, dist) return true;  // strela zasah

bool IsOut(int x1, int y1, int x2, int y2, int dst) {
	if (abs(x1-x2) * 0.8 > dst) return true;
	if (abs(y1-y2) * 0.8 > dst) return true;

	return false;
}


BITMAP *hload_bitmap(char *filename) {
	BITMAP   *bmp;
	PALETTE   pal;
	
	bmp = load_bitmap(filename, pal);
	if (bitmap_color_depth(screen) == 8) {
		PALETTE   glob; // Globlani paleta

		get_palette(glob);
		if (pal == glob) return bmp;
		
		int       i,j;
		unsigned char   *c;

		j = bmp->w * bmp->h;
		c = bmp->line[0];
		
		for (i = 0; i < j; i++) {
			*c = bestfit_color(glob, pal[*c].r, pal[*c].g, pal[*c].b);
			c++;
		}
	}
	return bmp;
}

void hprepare_pal() {
	PALETTE   glob; // bloblani paleta
	int       i;
	
	get_palette(glob);

	for (i = 0; i < 255; i++)
		if (glob[i].r == 255 && glob[i].g == 0 && glob[i].b == 255) {
			glob[i].r = 0;
			glob[i].g = 0;
			glob[i].b = 0;
		}

	glob[0].r = 255;
	glob[0].g = 0;
	glob[0].b = 255;
	
	set_palette(glob);
}
