#ifndef _ZBRANE_PARAMS_INCLUDE_
#define _ZBRANE_PARAMS_INCLUDE_

#define MAX_ZBRANE      7  // pocet zbraani
#define MAX_STREL      10  // pocet druhu streliva
#define MAX_POWERUPS   13
#define MAX_ZBRAN_ANIM  6
#define MAX_KOUR        1

extern BITMAP*  b_strel[MAX_STREL];				// obrazky strel
extern BITMAP*  b_zbraneB[MAX_ZBRANE];				// velke obrazky zbrani
extern BITMAP*  b_zbrane[MAX_ZBRANE][MAX_ZBRAN_ANIM];				// male obrazky zbrani
extern BITMAP*  b_powerups[MAX_POWERUPS];			// obrazky bonusu

extern BITMAP*  b_kour[MAX_KOUR];			// obrazky bonusu

// bonusy
#define MAX_BONUS 5
extern BITMAP*  b_s_bonus[MAX_BONUS];			// obrazky bonusu u vojaka

#define BON_ZRYCHLENI   0  // zrychli panacka
#define BON_INVIS       1  // neviditelnost
#define BON_NESMRT      2  // nesmrtelnost
#define BON_2KULBA      3  // dvojnasobna strelba
#define BON_ZMRAZEN     4  // zmrazeni


// powerupy
#define PUP_ZRYCHLENI   0  // zrychli panacka
#define PUP_INVIS       1  // neviditelnost
#define PUP_NESMRT      2  // nesmrtelnost
#define PUP_2KULBA      3  // dvojnasobna strelba

#define PUP_LEKARNA     4  // doplnuje stity, nebo zdravi
#define PUP_NABOJE      5  // doplnuje naboje


typedef struct {
	char name[15]; //jmeno pusky
	int  rate;  // rychlost strelby
	int  strelaID; // typ streliva
	int  angle;  // uhlovy rozptyl
	int  dx,dy;  // posun zacatku strelby (aby se strilelo opravdu z hlavne)
	int  anim;   // pocet animaci zbrane
	bool so;     // pouze pri strelbe
	bool nad;    // zda se maji kreslit nad, nebo pod panacka
} st_Zbrane_params;

typedef struct {
	char    name[15];  // nazev
	double  speed;  // rychlost
	int     demage;  // schopnost nicit
	int     dist;  // dolet
   int     rng;   // velikost vybuchu
	int     attime; // strel najednou
	int	  strel;  // max pocet strel (u vojaka)
	int     raise;  // rychlost dorustani naboju
	int     explosive;  // zda vybuchuje ( do kolika buchu )
	bool    target;  // automireni
	int     eID;     // id explozni strely
	int     dead;   // typ smrti
	int     kour;   // delka koure za strelou
} st_GStela_params;

typedef struct {
	char   name[20];  // nazev
	int    typ;       // typ power upu
	int    health;    // pocet zivotu, ktere pridava
	int    shields;   // kolik pridava stitu
	int    nID;       // ID naboju, ktere pridava
	int    cnt;       // kolik jich pridava
} st_powerups;


const st_Zbrane_params  Zparams[MAX_ZBRANE] = {
	{ "Kulomet",      1,  0,   10, 22, 8, 4, true,  false},
	{ "Mrazic",       3,  1,    1, 23, 0, 4, false, false},
	{ "Granatomet",   4,  2,    1, 20, 0, 1, true,  false},
	{ "Plamenomet",   1,  4,    6, 30, 0, 3, false, false},
	{ "Plazmomet",    3,  5,    1, 23, 0, 4, false, false},
	{ "Brok",        10,  7,   25, 22, 0, 1, false, false},
	{ "Raketak",     20,  8,    0, 22, 6, 1, false, true},
};

const st_GStela_params  Nparams[MAX_STREL] = {
	{ "Kulky",        38,  35,  600,  0,  2, 150, 10,   0, false, 0, 0, 0},
	{ "Led",          31,  70,  500,  0,  1, 100, 20,   0, false, 0, 1, 0},
	{ "Granat",       22,   0,  200, 50,  1,  30, 50,  20, false, 3, 2, 0},
	{ "Granat buch",   3,  10,   30,  0,  1,   0,  0,   0, false, 0, 2, 0},
	{ "Plamen",       10, 100,  200,  0,  1, 130, 45,   0, false, 0, 3, 0},
	{ "Plazma",       29,  50,  250, 20,  1,  80, 30,  20, false, 6, 4, 0},
	{ "Plazma bum",    3,  15,   20,  0,  1,   0,  0,   0, false, 0, 4, 0},
	{ "Brok",         40,  50,  300,  0, 20,  30, 30,   0, false, 0, 5, 0},
	{ "Raketa",       25, 590, 2000, 70,  1,  10, 10,  20, false, 9, 6, 5},
	{ "Raketa buch",   3,  25,   40,  0,  1,   0,  0,   0, false, 0, 6, 0},
};

const st_powerups Pparams[MAX_POWERUPS] = {
	{ "LEKARNU",         PUP_LEKARNA, 700,   0, 0,   0},
	{ "BATERKU",         PUP_LEKARNA,   0, 700, 0,   0},

	{ "ZASOBNIK",        PUP_NABOJE,    0,   0, 0,  50},
	{ "FREONY",          PUP_NABOJE,    0,   0, 1,  20},
	{ "GRANATY",         PUP_NABOJE,    0,   0, 2,  10},
	{ "KANISTR BENZINU", PUP_NABOJE,    0,   0, 4,  40},
	{ "PLAZMA KYSELINU", PUP_NABOJE,    0,   0, 5,  20},
	{ "CHUTNY BROK",     PUP_NABOJE,    0,   0, 7,  10},
	{ "PAR RAKET",       PUP_NABOJE,    0,   0, 8,   5},

	{ "STEREOIDY",       PUP_ZRYCHLENI, 0,   0, 0,  400},
	{ "ZNEVIDITELNOVAC", PUP_INVIS,     0,   0, 0,  200},
	{ "SUPER STIT",      PUP_NESMRT,    0,   0, 0,  100},
	{ "CHLADIC HLAVNE",  PUP_2KULBA,    0,   0, 0,  400},
};

#endif
